#
# RevisionObjects
#
# Copyright (c) 2001-2003 by Philipp "philiKON" von Weitershausen
#
# This software is distributed under the terms of the Mozilla Public
# License (MPL)
#

"""
$Id: __init__.py,v 1.2 2003/05/20 21:09:20 philipp Exp $
"""

from AccessControl import ClassSecurityInfo
from Globals import InitializeClass

from Revisioner import Revisioner

# classes to patch
from OFS.DTMLDocument import DTMLDocument
from OFS.DTMLMethod import DTMLMethod
from OFS.Image import File, Image
from Products.ZSQLMethods.SQL import SQL
from Products.PythonScripts.PythonScript import PythonScript
from Products.ExternalMethod.ExternalMethod import ExternalMethod
from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate

classes_to_patch = [
    DTMLDocument,
    DTMLMethod,
    File,
    Image,
    SQL,
    PythonScript,
    ExternalMethod,
    ZopePageTemplate
    ]

for klass in classes_to_patch:
    for name in Revisioner.names:
        setattr(klass, name, getattr(Revisioner, name))

    # patch manage_options
    klass.manage_options = (
        (klass.manage_options[0],)
        + Revisioner.manage_options
        + klass.manage_options[1:]
        )

    # add permissions
    # we have go up the ass to reach the brain, i.e. go through the
    # class's __dict__
    ac_permissions = klass.__dict__.get('__ac_permissions__', ())
    ac_permissions += Revisioner.permissions
    klass.__dict__['__ac_permissions__'] = ac_permissions

    # make sure that permissions are re-read now that we monkeyd with
    # them
    InitializeClass(klass)
